/*

Scrivere un programma per la gestione dei clienti di un magazzino e degli acquisti dei prodotti. 
I clienti sono caratterizzati dalle seguenti informazioni: cognome, nome, codice cliente, categoria cliente (0=privati, 1=business).
Gli acquisti sono caratterizzati dalle seguenti informazioni: codice cliente, codice prodotto, importo prodotto, tipo prodotto (0..4).
I clienti sono inseriti in un vettore di 2 liste, una per ogni categoria di cliente. 
Gli acquisti sono inseriti in una tabella allocata dinamicamente avente 5 righe, una  per tipo di prodotto.

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1. Inserimento ordinato rispetto al codice cliente nel vettore di liste di una nuovo cliente; 
2. Eliminazione del primo cliente da una lista dopo la sua visualizzazione (chiedere la categoria);
3. Inserimento di un nuovo acquisto;
4. Visualizzazione degli acquisti relativi a un cliente (chiedere il codice cliente);
5. Salvataggio su file degli acquisti;
6. Lettura da file degli acquisti precedentemente salvati e inserimento in tabella;

Liberare la memoria allocata dinamicamente.

*/



#include <stdio.h>
#include <stdlib.h>
struct cliente
{
       char cognome[20];
       char nome[30];
       long codice;
       int categoria;
};
struct atomo
{
       struct cliente dato;
       struct atomo *next;
};
struct acquisto
{
       long cliente;
       long prodotto;
       float importo;
       int tipo_prodotto;
};

void da_testa(struct atomo **ptl);
void leggi_cliente(struct cliente *c);
void inserisci_cliente(struct atomo **L, struct cliente c );
void elimina_cliente(struct atomo **L);
void leggi_acquisto(struct acquisto *l);
void inserisci_acquisto(struct acquisto **T,int *n,struct acquisto l);
void visualizza_acquisti(struct acquisto *T[5],int *N);
void salva_su_file(struct acquisto *T[5],int *N);
void leggi_da_file(struct acquisto *T[5],int *N);

main()
{
      struct atomo *L[2];
      struct cliente c;
      struct acquisto *T[5],l;
      int N[5],scelta,i;
      for(i=0;i<2;i++)
           L[i]=NULL;
      for(i=0;i<5;i++)
      {
          T[i]=NULL;
          N[i]=0;
      }
      
      
      do{
         printf("Scegli tra: \n");
         printf("1)Inserisci un nuovo cliente\n");
         printf("2)Elimina un cliente dopo averlo visualizzato\n");
         printf("3)Inserisci un nuovo acquisto\n");
         printf("4)Visualizza acquisti relativi a un cliente\n");
         printf("5)Salva su file gli acquisti \n");
         printf("6)Leggi da file\n"); 
         printf("0)Termina programma\n");
         scanf("%d",&scelta);
         switch(scelta)
         {
                       case 1: leggi_cliente(&c);
                               i=c.categoria;
                               inserisci_cliente(&L[i],c);
                               break;
                       case 2: elimina_cliente(L);
                               break;
                       case 3: leggi_acquisto(&l);
                               i=l.tipo_prodotto;
                               inserisci_acquisto(&T[i],&N[i],l);
                               break;
                       case 4: visualizza_acquisti(T,N);
                               break;
                       case 5: salva_su_file(T,N);
                               break;
                       case 6: leggi_da_file(T,N);
                               break;
         }
         }while(scelta!=0);
        
        /* Liberazione della memoria allocata dinamicamente */
        
         for(i=0;i<2;i++)
            while(L[i]!=NULL)
              da_testa(&L[i]);
              
         for(i=0;i<5;i++)
         free(T[i]);
}




void da_testa(struct atomo **ptl)
{
     struct atomo *a;
     a=*ptl;
     *ptl=a->next;
     free(a);
}

void leggi_cliente(struct cliente *c)
{
     printf("Cognome: ");
     scanf("%s",c->cognome);
     printf("Nome: ");
     scanf("%s",c->nome);
     printf("Codice cliente: ");
     scanf("%ld",&c->codice);
     printf("Categoria cliente: ");
     scanf("%d",&c->categoria);
}

void inserisci_cliente(struct atomo **L, struct cliente c )
{
  
     struct atomo *a, *l1,*l2;
     int i;
     
     a=malloc(sizeof(struct atomo));
     if(a==NULL)
     return;
     
     a->dato=c;
      
     if(*L==NULL || c.codice < (*L)->dato.codice)  /* inserimento in testa */
      {
        a->next=*L;
        *L=a;
        return;
      }
     /* inserimento in posizione successiva alla prima */ 
     l2=*L;
     l1=l1->next;
     while(l1)
       if (c.codice< l1->dato.codice)
            break;
       else {
              l2=l1;
              l1=l1->next;
            }
     a->next=l1;       
     l2->next=a;
            
}

void elimina_cliente(struct atomo *L[2])
{
     int i;
     long codice;
     struct atomo *l1,*l2;
     printf("Categoria del cliente da eliminare: ");
     scanf("%d",&i);
     
     
     if(L[i]==NULL)
     {
                   printf("Lista vuota\n");
                   return;
     }
     
     /* eliminazione del primo elemento della lista dopo la sua visualizzazione */
      printf("\nCognome: %s\n",L[i]->dato.cognome);
      printf("Nome: %s\n\n",L[i]->dato.nome);
      da_testa(&L[i]);
     
     
}

void leggi_acquisto(struct acquisto *l)
{
     printf("Codice cliente: ");
     scanf("%ld",&l->cliente);
     printf("Codice prodotto: ");
     scanf("%ld",&l->prodotto);
     printf("Importo prodotto: ");
     scanf("%f",&l->importo);
     printf("Tipo prodotto: ");
     scanf("%d",&l->tipo_prodotto);
}
void inserisci_acquisto(struct acquisto **T,int *n,struct acquisto l)
{
     struct acquisto *a;
     
     a=realloc(*T,(*n+1)*sizeof(struct acquisto));
     if(a==NULL)
     return;
     *T=a;
     (*T)[*n]=l;
     (*n)++;
}
void visualizza_acquisti(struct acquisto *T[5],int *N)
{
     int tipo,j;
     long cliente;
     printf("Codice cliente: ");
     scanf("%ld",&cliente);  
     
   
     for(tipo=0;tipo<6;tipo++)
         for(j=0;j<N[tipo];j++)
         if( T[tipo][j].cliente==cliente)
             {
                printf("\nCodice prodotto: %ld\n",T[tipo][j].prodotto);
                printf("Importo prodotto: %f\n",T[tipo][j].importo);
                printf("Tipo prodotto: %d\n\n",T[tipo][j].tipo_prodotto);
             }
}


void salva_su_file(struct acquisto *T[5],int *N)
{
     FILE *pf;
     int i,tipo;
     long cliente;
     
    
     pf=fopen("acquisti.txt","w");
     if(pf!=NULL)
     {
                 for(tipo=0;tipo<5;tipo++)
                                       
                          fwrite(T[tipo],sizeof(struct acquisto),N[tipo],pf);
                 fclose(pf);
     }
     else printf("Errore in scrittura\n");
}
void leggi_da_file(struct acquisto *T[5],int *N)
{
     FILE *pf;
     struct acquisto temp;
     int i;
     pf=fopen("acquisti.txt","r");
     if(pf!=NULL)
     {
                 while(fread(&temp,sizeof(struct acquisto),1,pf)>0)
                 {
                                                 i=temp.tipo_prodotto;
                                                 inserisci_acquisto(&T[i],&N[i],temp);
                 }
                 fclose(pf);
     }
     else printf("Errore: il file non esiste\n");
}

