/*
Scrivere un programma per la gestione degli studenti e degli esami.
Gli studenti sono caratterizzati dalle seguenti informazioni: cognome, nome, matricola codice corso di laurea (0..3).
Gli esami sono caratterizzati dalle seguenti informazioni: matricola studente, codice materia (0..9), giorno dellesame, voto, corso di laurea (0..3). 
Gli studenti sono inseriti in un vettore di 4 liste,  una per ogni corso di laurea. 
Gli esami sono inseriti in una tabella allocata dinamicamente avente 10 righe, una  per materia.

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1. Inserimento  nel vettore di liste di una nuovo studente; 
2. Eliminazione di uno studente dopo averlo visualizzato ( chiedere matricola e codice corso);
3. Inserimento di una nuovo esame;
4. Visualizzazione degli esami relativi a un certo corso di laurea (chiedere il corso di laurea);
5. Salvataggio su file degli esami;

All'avvio del programma inizializzare la tabella degli esami leggendo da file gli esami precedentemente salvati.

Liberare la memoria allocata dinamicamente.

*/
#include <stdio.h>
#include <stdlib.h>

struct studente{
       char nome[20],cognome[20];
       long matricola;
       int corso;
       };
struct esame{
       long matricola;
       int codmateria,voto,corso;
       char data[12];
       };
struct atomo {
       struct studente dato;
       struct atomo *next;
       };
       
void da_testa (struct atomo **tl)
{
     struct atomo *a;
     
     a=*tl;
     *tl=a->next;
     free(a);
}

void leggi_studente(struct studente *s)
{
     printf("nome:  ");
     scanf("%s", s->nome);
     printf("cognome:  ");
     scanf("%s", s->cognome);
     printf("matricola:  ");
     scanf("%ld", &s->matricola);
     printf("codice corso di laurea:  ");
     scanf("%d", &s->corso);
}

void ins_studente (struct atomo *L[4])
{
     struct studente s;
     struct atomo *a;
     int i;
     
     a=malloc(sizeof(struct atomo));
     if(a==NULL)
        return;
     
     leggi_studente(&s);
     i=s.corso;
     
     a->dato=s;
     a->next=L[i];
     L[i]=a;
}

     
     
void elimina_studente (struct atomo *L[4])
{
     int i;
     long matricola;
     struct atomo *l1,*l2;
     
     printf("matricola dello studente da eliminare:  ");
     scanf("%ld", &matricola);
     printf("corso dello studente:  ");
     scanf("%d", &i);
          
     if(L[i]==NULL)
     {
                printf("lista vuota\n");
                return;
     }
     if(matricola==L[i]->dato.matricola)
     /* elimino l'elemento in testa dopo la sua visulizzazione*/
     {
        printf("nome:  %s\n", L[i]->dato.nome);
        printf("cognome: %s\n", L[i]->dato.cognome);
        da_testa(&L[i]);
        return;
     }
     /* ricerca dell'elemento da eliminare*/
     l1=L[i]->next;
     l2=L[i];
     while(l1!=NULL)
          if(matricola==l1->dato.matricola)
              /* elimino l'elemento trovato dopo la sua visulizzazione*/
          {
                                       l2->next=l1->next;
                                       printf("nome:  %s\n", l1->dato.nome);
                                       printf("cognome: %s\n", l1->dato.cognome);
                                       free(l1);
                                       return;
          }
          else
          {
               l2=l2->next;
               l1=l1->next;
          }
               
    printf("studente non trovato\n");
   
}

void leggi_esame (struct esame *e)
{
     printf("matricola studente:  ");
     scanf("%ld", &e->matricola);
     printf("codice materia(0..9):  ");
     scanf("%d", &e->codmateria);
     printf("data esame:  ");
     scanf("%s", e->data);
     printf("voto:  ");
     scanf("%d", &e->voto);
     printf("corso di laurea:  ");
     scanf("%d", &e->corso);
}

void ins_esame (struct esame **T, int *n, struct esame e)
{
     struct esame *a;
     a=realloc(*T,(*n+1)*sizeof(struct esame));
     
     if(a==NULL)
       return;
       
    *T=a;
    (*T)[*n]=e;
    (*n)++;
} 

void vis_esami (struct esame *TB[10], int N[10])
{
     int materia,j;
     int c;
     
     printf("quale corso vuoi visualizzare:  ");
     scanf("%d", &c);
     
     /* per tutte le materie */
     for(materia=0;materia<10;materia++)     
         for(j=0;j<N[materia];j++)
             if(TB[materia][j].corso==c)
             {
                 printf("matricola: %ld\n", TB[materia][j].matricola);
                 printf("data esame: %s\n", TB[materia][j].data);
                 printf("voto: %d\n", TB[materia][j].voto);
             }
}


void salva_file( struct esame *TB[10], int N[10])
{
     FILE *pf;
     int i,j;
     
     pf=fopen("esami.txt", "w");
     if(pf!=NULL)
     {
                 for(i=0;i<10;i++)   
                    for(j=0;j<N[i];j++)
                          fwrite( &TB[i][j],sizeof(struct esame),1,pf);
                          
                 fclose(pf);
     }
     else printf("errore in scrittura\n");
}

void inizializza(struct esame *TB[10], int N[10])
{
     FILE *pf;
     struct esame e;
     int i;
     
     pf=fopen("esami.txt","r");
     if(pf!=NULL)
     {
                 while(fread(&e, sizeof(struct esame),1,pf)>0)
                 {
                    i=e.codmateria;
                    ins_esame(&TB[i], &N[i], e);
                 }
                 
                 fclose(pf);
                                      
     }
     else printf("errore:file inesistente\n");
}
    
main()
{
      struct atomo *L[4];
      struct esame *TB[10],e;
      int N[10],i,scelta;
      
      
      for(i=0;i<4;i++)
          L[i]=NULL;
          
      for(i=0;i<10;i++)
      {
        TB[i]=NULL;
        N[i]=0;
      }
      
      inizializza(TB,N);
      
      
      do{
                       printf("\n-----MENU-----\n");
                       printf("Scegli tra:\n");
                       printf(" 1) Inserisci un nuovo studente\n");
                       printf(" 2) Elimina uno studente\n");
                       printf(" 3) Inserisci un nuovo esame\n");
                       printf(" 4) Visualizza esami relativi ad un certo corso di laurea\n");
                       printf(" 5) Salvataggio su file\n");
                       printf(" 0) Fune esecuzione\n");
                       scanf("%d", &scelta);
                       switch(scelta){
                                      case 1: ins_studente(L);
                                              break;
                                      case 2: elimina_studente(L);
                                              break;
                                      case 3: leggi_esame(&e);
                                              i=e.codmateria;
                                              ins_esame(&TB[i], &N[i], e);
                                              break;
                                      case 4: vis_esami(TB,N);
                                              break;
                                      case 5: salva_file(TB,N);
                                              break;
                                      
                                              
                                      default:;
                                      }
      }while(scelta!=0);
      
      for(i=0;i<4;i++)
          while(L[i]!=NULL)
               da_testa(&L[i]);
               
      for(i=0;i<10;i++)
          free(TB[i]);
}
       
       
