/*
Scrivere un programma C per la gestione delle informazioni relative alle operazione di una banca. Ciascun cliente  caratterizzato dalle seguenti informazioni: nominativo,  numero di conto corrente, saldo.  Si assuma che le informazioni di tutti i clienti siano presenti in una lista.
Ogni operazione  caratterizzata dalle seguenti informazioni: numero di conto corrente, codice identificativo tipo operazione (deposito=0, prelievo=1), costo servizio.
Ogni nuova operazione viene inserita in un'unica coda dopo avere verificato che il richiedente sia un correntista della banca ovvero dopo avere verificato che i suoi dati siano presenti nella lista dei correntisti.
Quando il primo elemento di una delle due code viene servito, viene aggiornato il saldo del correntista e i suoi dati vengono eliminati dalla coda.
Il programma deve essere caratterizzato da un menu con le seguenti funzioni:
1.	Inserimento nella lista dei correntisti;
2.	Inserimento in coda di una nuova operazione dopo avere verificato la presenza del correntista nella lista dei correntisti;
3.	Servizio della prima operazione della coda relativa ad un tipo di operazione;
4.	Visualizzazione del nome e del saldo di un correntista dopo averne effettuato la ricerca nella lista dei correntisti;
5.	Visualizzazione del contenuto della coda.

*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

struct cliente {
	char nominativo[30];
	long ncc;
	long saldo;
	struct cliente *next;
};


struct operazione {
	long ncc;
	int tipo;
	long importo;
    struct operazione *next;
};

struct coda {
	struct operazione *primo,*ultimo;
};

void menu(void);
void inlista(struct cliente **tl);
struct cliente * ricerca(struct cliente *l, long ncc);
void incoda(struct coda *Q, struct cliente *l);
void outcoda(struct coda *Q, struct cliente *l);
void visualizza_elemento(struct cliente *l);
void visualizza_coda(struct coda *Q);
void elimina_lista(struct cliente **tl);
void elimina_coda (struct coda *Q);

void main(void)
{ struct cliente *testa_lista=NULL;
  struct coda Q;
  int i,scelta;

  Q.primo=NULL;
  Q.ultimo=NULL;


  do {
   menu();
   scanf("%d",&scelta);
   switch(scelta) {
 	case 1:	inlista(&testa_lista);
	  		break;
	case 2:	incoda(&Q,testa_lista);
			break;
	case 3:	outcoda(&Q,testa_lista);
			break;
	case 4: visualizza_elemento(testa_lista);
			break;
	case 5: visualizza_coda(&Q);
			break;
	default:; }
   } while(scelta);

 elimina_lista(&testa_lista);
 elimina_coda(&Q);
}

void menu(void)
{
	printf("\nScegli una delle seguenti opzioni\n");
	printf("\n1) Inserisci un nuovo cliente\n");
	printf("\n2) Inserisci in coda\n");
	printf("\n3) Servi coda\n");
	printf("\n4) Visualizza un elemento\n");
	printf("\n5) Visualizza coda\n");
	printf("\n0) Fine programma\n");
}

void inlista(struct cliente **tl)
{
	struct cliente *aux,*l;

    /* Allocazione della memoria per il nuovo elemento */
	aux=malloc(sizeof(struct cliente));
	if(!aux)
		{ printf("\nMemoria non allocata\n");
	      return;
	    }
	/* lettura */
	printf("\nNominativo: ");
	scanf("%s",aux->nominativo);
	printf("\nNum. cc: ");
	scanf("%ld",&aux->ncc);
	printf("\nDeposito iniziale: ");
	scanf("%ld",&aux->saldo);

	/* Inserimento  */

    aux->next=*tl;
    *tl=aux;
}


struct cliente * ricerca(struct cliente *l, long ncc)
{

  while(l)
    if(l->ncc==ncc)
         break;
    else l=l->next;
 return l;
}


void incoda(struct coda *Q, struct cliente *l)
{
  struct cliente *a;
  struct operazione *op;
  long ncc;

  /* Ricerca del cliente nella lista dei clienti */
  printf("\nNumero di conto corrente: ");
  scanf("%ld",&ncc);

  a=ricerca(l,ncc);

  if(!a) {printf("\nNon e' un cliente\n");
		  return;
	     }
  /* Inserimento in coda */
  op=malloc(sizeof(struct operazione));
  if(!op) { printf("\nMemoria non allocata\n");
            return;
          }
  do {
  printf("Tipo operazione: Prelievo=0, Deposito=1\n");
  scanf("%d",&op->tipo);
  } while (op->tipo<0 || op->tipo>1);

  printf("Importo: ");
  scanf("%ld",&op->importo);
  op->ncc=ncc;
  op->next=NULL;

  if(Q->primo==NULL)
	  Q->primo=op;
    else Q->ultimo->next=op;
  Q->ultimo=op;

}


void outcoda(struct coda *Q, struct cliente *l)
{
 int tipo;
 struct operazione *ap;
 struct cliente *a;


 if(Q->primo==NULL)
   { printf("\nCoda vuota\n");
     return;
   }

  ap=Q->primo;
  /* Aggiornamento del saldo */
  a=ricerca(l,ap->ncc);
  if(a)
	  {
       if(ap->tipo==0)
           a->saldo=a->saldo-ap->importo;
	   else
		   a->saldo=a->saldo+ap->importo;
	  }
  else printf("\nNon e' piu' un cliente\n");

 /* Out coda */
 Q->primo=ap->next;
 free(ap);

 if(Q->primo==NULL)
    Q->ultimo=NULL;

}

void visualizza_elemento(struct cliente *l)
{
  struct cliente *a;
  struct operazione *op;
  long ncc;

  /* Ricerca del cliente nella lista dei clienti */
  printf("\nNumero di conto corrente: ");
  scanf("%ld",&ncc);

  a=ricerca(l,ncc);

  if(!a) {printf("\nNon e' un cliente\n");
		  return;
	     }
  printf("\nNominativo: %s\n",a->nominativo);
  printf("Saldo: %ld\n",a->saldo);

}


void visualizza_coda(struct coda *Q)
{
 int tipo;
 struct operazione *ap;

 ap=Q->primo;
 while(ap)
   { printf("Num. con. corr: %ld\n",ap->ncc);
     printf("Tipo: %d\n",ap->tipo);
	 printf("Importo: %ld\n",ap->importo);
	 ap=ap->next;
   }

}

void elimina_lista(struct cliente **tl)
{
	struct cliente *aux;

	while(*tl)
	{
	  aux=*tl;
	  *tl=aux->next;
	  free(aux);
	}
}

void elimina_coda (struct coda *Q)
{
	struct operazione *op;

	while(Q->primo)
		{ 	op=Q->primo;
			Q->primo=op->next;
		    free(op);
	    }
	Q->ultimo=NULL;
}


